import unittest
import xmltreeview
inputtext1="""<system >
  <scanlist >
    <scan >
      <s >DATA/data_ref_w.dat</s>
      <f >"wavelenghts_col"  3 </f>
      <f >"angles_col"  1 </f>
      <f >"refle_col"  2 </f>
      <f >"weight_col"  1.0 </f>
      <f >"angle_factor"  arccos(-1)/180.0 </f>
      <f >"norm" nomrLE 1191671.0 100000 20000000 </f>
      <f >"noise"  3.031721e-07 1.0e-9 1.0e-6 </f>
      <f >"CutOffRatio"  0.009644845 0.00025 0.2 </f>
    </scan>
  </scanlist>
</system>"""
partest1=2
coltest1=5
signal1 ="-"
inputtext1_impl="""<system >
  <scanlist >
    <scan >+++</scan>
  </scanlist>
</system>"""




class testCmlTreeView(unittest.TestCase):
    def setUp(self):
        pass
    
    def tearDown(self):
        pass

    def testInitializeWithText(self):
        tv=xmltreeview.XmlTreeView()
        tv.initializeString(inputtext1)
        tv.expandAll()
        content = tv.text()
        self.assertEquals(content, inputtext1)
        tv.signalat(partest1, coltest1,"-")
        content = tv.text()
        self.assertEquals(content, inputtext1_impl)


if __name__ == "__main__":
    unittest.main()
